/************************************************************************************/
/*  Program name CAPFNDIMP_REQUEST_SETS_TL.sql                                      */
/*  Creater:  Chan Billy Ka Keung (PCCW - UniHub)                                   */
/*************   History   *************************                                */
/* 01 FEB, 2006   CHAN Billy Ka Keung         First created                         */
/************************************************************************************/

SET SERVEROUTPUT ON SIZE 1000000;

DECLARE

	lv_PrOG_ID		VARCHAR2(100) 	:=	'CAPFNDIMP_REQUEST_SETS_TL';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FND_REQUEST_SETS_TL;

	lv_Next_Seq_ID	NUMBER;
BEGIN

	UPDATE
		FND_REQUEST_SETS_TL
	SET
		USER_REQUEST_SET_NAME	=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(USER_REQUEST_SET_NAME,1,4),USER_REQUEST_SET_NAME)
	WHERE	(Application_ID,Request_Set_ID,Language,User_Request_Set_Name) IN
		(
			SELECT
				Application_ID,Request_Set_ID,Language,User_Request_Set_Name
			FROM
				CRST_FND_REQUEST_SETS_TL
		);

	FOR C1 IN Cur_F LOOP
			BEGIN
				INSERT INTO FND_REQUEST_SETS_TL
				VALUES
				(
				C1.APPLICATION_ID,
				CAPBRIMP_MAPPING.GetRequestSetIDMapping(C1.REQUEST_SET_ID),
				C1.LANGUAGE,
				C1.SOURCE_LANG,
				C1.CREATION_DATE,
				CAPBRIMP_COMMON.GetUser(C1.CREATED_BY_NAME),
				C1.LAST_UPDATE_DATE,
				CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_BY_NAME),
				C1.LAST_UPDATE_LOGIN,
				C1.USER_REQUEST_SET_NAME,
				C1.DESCRIPTION
				);
			EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_lINe(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count		:= lv_Scc_Count + 1;
	END LOOP;

	IF lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count - lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/